﻿init python:
    class book:
        def __init__(self, name, inf, paragraphs, numbers = None):
            self.name = name
            self.inf = inf
            self.paragraphs = paragraphs
            self.page = 0
            self.numbers = numbers
        def change_page(self, page):
            self.page += page
            if self.page < 0:
                self.page = 0
            elif self.page > len(self.paragraphs)-1:
                self.page = len(self.paragraphs)-1
transform book_animation:
    zoom 0.01 alpha 0 xoffset 1000 yoffset 800
    parallel:
        ease .4 zoom 1 alpha 1
    parallel:
        ease .2 xoffset 0 yoffset 0

screen book_reader(b):
    modal True
    # Book
    fixed:
        at book_animation
        fit_first True
        add "reading_book"
        hbox:
            spacing 140 align .5,.5
            frame:
                xysize 500,900 background None 
                text b.paragraphs[b.page][0] size 50 color "#000" font "fonts/Quikhand.ttf"
                if not b.numbers is None:
                    text str((1 + (b.page*2)) + b.numbers) align 0.0,1.0 size 50 color "#000" font "fonts/Quikhand.ttf"
            frame:
                xysize 500,900 background None
                text b.paragraphs[b.page][1] size 50 color "#000" font "fonts/Quikhand.ttf"
                if not b.numbers is None:
                    text str((2 + (b.page*2)) + b.numbers) align 1.0,1.0 size 50 color "#000" font "fonts/Quikhand.ttf"
        for i in b.paragraphs[b.page][2]:
            add i[0] offset i[1],i[2] align .5,.5
    
    # Navigation buttons
    hbox:
        align .5,.5 xfill True
        if b.page > 0:
            button:
                xalign 0.0 background "#fff3" padding 20,20
                text _("Back")
                action Function(b.change_page, -1) keysym "a"
        if b.page < len(b.paragraphs)-1:
            button:
                xalign 1.0 background "#fff3" padding 20,20
                text _("Next")
                action Function(b.change_page, 1) keysym "d"
    # Close button
    button:
        align 1.0,0.0 background "#fff3" xysize 80,80
        text _("X") align .5,.5
        action Hide("book_reader")

screen note_reader(b):
    modal True
    fixed:
        align .5,.5
        at book_animation
        fit_first True
        add "reading_paper"
        frame:
            padding 100,100 background None 
            vbox:
                spacing 10 align .5,.5
                text b.paragraphs[b.page][0] size 50 color "#000" font "fonts/Quikhand.ttf"
                text b.paragraphs[b.page][1] size 50 color "#000" font "fonts/Quikhand.ttf"

        if not b.numbers is None:
            text str((1 + b.page) + b.numbers) align 1.0,1.0 offset -50,-50 size 50 color "#000" font "fonts/Quikhand.ttf"

        for i in b.paragraphs[b.page][2]:
            add i[0] offset i[1],i[2] align .5,.5

    # Navigation buttons
    hbox:
        align .5,.5 xfill True
        if b.page > 0:
            button:
                xalign 0.0 background "#fff3" padding 20,20
                text _("Back")
                action Function(b.change_page, -1) keysym "a"
        if b.page < len(b.paragraphs)-1:
            button:
                xalign 1.0 background "#fff3" padding 20,20
                text _("Next")
                action Function(b.change_page, 1) keysym "d"
    # Close button
    button:
        align 1.0,0.0 background "#fff3" xysize 80,80
        text _("X") align .5,.5
        action Hide("note_reader")

# Define a book or two
default the_free_lie = book(
    name = _("The free lie"),
    inf = _("By Jafar Barmaki"),
    paragraphs = [
        [
            _("In a grand scale, free doesn't exist. Everything has it's own cost and somebody is paying that cost, that somebody is often you.\nThe iron in the ground is free, but you need to pay for an iron axe simply because somebody had to dig the iron out of the ground."),
            _("Somebody had to gather wood for the bloomery, somebody had to hammer the bloom into iron and somebody had to shape it into an axe.\nIt's useless to you when it's free and even if you do all of those yourself, it wouldn't be free, you had to pay for it with your labor and time."),
            []
        ],
        [
            _("When you find a sack of coins on the ground, it looks like free money for you, but comes as a heavy cost to somebody else."),
            _("When a merchant feels generous with votive offerings, it might look like a free meal that comes out of his pockets to the commoners, but the cost often comes out of the pockets of his customers.\nHe kept his house, his shop, his wealth and his social status. Nothing changes for him, if anything, this show of duplicity was a ploy to push him upwards in the social ranks."),
            [
                ["coin_bag", -320,190],
            ]
        ],
        [
            _("In other hand, he cover his costs by selling his merchandise for a little more. A cost that everybody else has to pay for him."),
            _("You can't think of anything that comes free of cost, some effort had to go into collecting, moving or shaping it. Therefore, next time you're offered something for free, ask, what's the catch?"),
            []
        ],
    ],
    numbers = 0
)

default odd_notes = book(
    name = _("The free lie"),
    inf = _("By Jafar Barmaki"),
    paragraphs = [
        [
            _("Slain the daws\nDraw the blood\nAdd nightshade\nLeave in dark"),
            _("The blood will become sentient. It will harden on the outside. soft inside. The souls will suffer and go on rampage.\nAnybody as much as look at it will suffer a terrible death."),
            [
                ["dow_drawing", 0, 360],
            ]
        ],
        [
            _("Recipe copy\n\nSlain the daws\nDraw the blood\nAdd nightshade\nLeave in dark"),
            _("The blood will become sentient. It will harden on the outside. soft inside. The souls will suffer and go on rampage.\nAnybody as much as look at it will suffer a terrible death."),
            []
        ],
    ],
    numbers = 0
)

screen inspection_test():
    hbox:
        align .5,.5 spacing 100
        button:
            vbox:
                add "book_icon" align .5,.5
                text _("Read the book")
            action Show("book_reader", b = the_free_lie)
        button:
            vbox:
                add "notes_icon" align .5,.5
                text _("Read the notes")
            action Show("note_reader", b = odd_notes)
        button:
            vbox:
                add "item_icon" align .5,.5
                text _("Inspect item")
            action NullAction()


label book_reader_example:
    call screen inspection_test




